using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace WNApiUse
{
    class Program
    {
        static void Main(string[] args)
        {
            // Path al directorio de diccionarios. IMPORTANTE que acabe en \
            Wnlib.WNCommon.path = @"path\to\dict\";

            string word = "drive";

            WnLexicon.WordInfo wi = WnLexicon.Lexicon.FindWordInfo(word, true); //true indica buscar por variaciones de la palabra
            if (wi.senseCounts != null) {
                Console.WriteLine("Word: " + word);
                Console.WriteLine("Senses: ");
                Console.WriteLine("Senses unknown: " + wi.senseCounts[0]);
                Console.WriteLine("Senses noun: " + wi.senseCounts[1]);
                Console.WriteLine("Senses verb: " + wi.senseCounts[2]);
                Console.WriteLine("Senses adjective: " + wi.senseCounts[3]);
                Console.WriteLine("Senses adverb: " + wi.senseCounts[4]);

                // Part of Speech a buscar. Dos opciones:
                Wnlib.PartsOfSpeech pos = Wnlib.PartsOfSpeech.Noun; // Un POS en concreto
                //Wnlib.PartsOfSpeech pos = wi.partOfSpeech; // El POS ms comn del trmino

                // Forma 1: sinnimos en todos los synsets
                string[] sinonimos = WnLexicon.Lexicon.FindSynonyms(word, pos, true);

                // Forma 2: relaciones en cada synset por separado
                Wnlib.Search sr = new Wnlib.Search(word, true,pos.ToString().ToLower() , "SYNS", 0); // 0 = buscar todos los synsets
                int numSenses = sr.senses.Count; // Es igual a wi.senseCounts[] del POS correspondiente

                for (int sense = 1; sense <= numSenses; sense++) { // el 0 sera todos los synsets a la vez
                    sr = new Wnlib.Search(word, true, pos.ToString().ToLower(), "SYNS", sense); // buscar slo en el synset sense
                    Console.WriteLine();
                    Console.WriteLine("Synset " + sense + " Def: " + sr.senses[0].defn);
                    foreach (Wnlib.Lexeme lex in sr.lexemes.Keys)
                        Console.WriteLine(lex.word);

                }
            }
            Console.ReadLine();
        }
    }
}

// **************************
// TIPOS POSIBLES DE RELACIONES
// **************************
//new PointerType("!", "ANTPTR", "Antonyms"); // 1
//new PointerType("@", "HYPERPTR", "Synonyms/Hypernyms"); // 2
//new PointerType("~", "HYPOPTR", "Hyponyms");  // 3
//new PointerType("*", "ENTAILPTR", "Entailment");  // 4
//new PointerType("&", "SIMPTR", "Similarity"); // 5
//new PointerType("#m", "ISMEMBERPTR", "Member Holonyms"); // 6
//new PointerType("#s", "ISSTUFFPTR", "Substance Holonyms");  // 7
//new PointerType("#p", "ISPARTPTR", "Part Holonyms");  // 8
//new PointerType("%m", "HASMEMBERPTR", "Member Meronyms"); // 9
//new PointerType("%s", "HASSTUFFPTR", "Substance Meronyms"); // 10
//new PointerType("%p", "HASPARTPTR", "Part Meronyms"); // 11
//new PointerType("%", "MERONYM", "Meronyms"); // 12
//new PointerType("#", "HOLONYM", "Holonyms"); // 13
//new PointerType(">", "CAUSETO", "'Cause To'"); // 14
//new PointerType("<", "PPLPTR", ""); // 15
//new PointerType("^", "SEEALSOPTR", "See also"); // 16
//new PointerType("\\", "PERTPTR", "Pertainyms"); // 17
//new PointerType("=", "ATTRIBUTE", "Attributes"); // 18
//new PointerType("$", "VERBGROUP", ""); // 19
//new PointerType("+", "NOMINALIZATIONS", ""); // 20 // TDMS 26/8/05 - re-added nominalizations which was commented
//new PointerType(";", "CLASSIFICATION", "Domain"); // 21
//new PointerType("-", "CLASS", "Domain Terms"); // 22
//new PointerType("", "SYNS", "Synonyms"); // 23
//new PointerType("", "FREQ", "Frequency"); // 24
//new PointerType("", "FRAMES", "Sample Sentences"); // 25 // TDMS 05/03/09 - fix suggested by Scott Zhang - reported 09/01/2009
//new PointerType("", "COORDS", "Coordinate Terms"); // 26
//new PointerType("", "RELATIVES", "Relatives"); // 27
//new PointerType("", "HMERONYM", "Meronyms"); // 28
//new PointerType("", "HHOLONYM", "Holonyms"); // 29
//new PointerType("", "WNGREP", "Grep"); // 30
//new PointerType("", "OVERVIEW", "Overview"); // 31
//new PointerType(";c", "CLASSIF_CATEGORY", "Classification Category"); // 32
//new PointerType(";u", "CLASSIF_USAGE", "Classification Usage"); // 33
//new PointerType(";r", "CLASSIF_REGIONAL", "Classification Regional"); // 34
//new PointerType("-c", "CLASS_CATEGORY", "Class Category"); // 35
//new PointerType("-u", "CLASS_USAGE", "Class Usage"); // 36
//new PointerType("-r", "CLASS_REGIONAL", "Class Regional"); // 37
//new PointerType("@i", "INSTANCE", "Instance"); // 38
//new PointerType("~i", "INSTANCES", "Instances"); // 39